## locksmith-1.0.tar.gz

=== Makefile ===
AT = @
LOCKSMITH_MODULES = \
  rmalias \
	lockutil \
	worklist \
	dotpretty \
	bansheemlifc \
	falsecfl \
	mycfl \
	livevars \
	locksettings \
	uniqueness \
	labelname \
	labelflow \
	controlflow \
	lockprofile \
	lockstate \
	shared \
	correlation \
	semiunification \
	locktype \
	lockalloc \
#	lockpick \
#	locksmith \
#	stmizer

LOCKSMITH_CMODULES = bansheeifc
CP4S        += locksettings.p4

BANSHEE = $(PWD)/banshee
DYCKCFL_DIR = $(BANSHEE)/dyckcfl
ENGINE_DIR = $(BANSHEE)/engine
REGION_DIR = $(BANSHEE)/libcompat
LINKFLAGS = \
	     $(DYCKCFL_DIR)/dyckcfl.o $(DYCKCFL_DIR)/mr_dyckcfl.o \
	     $(REGION_DIR)/libregions.a \
	     $(ENGINE_DIR)/libnsengine.a
CAML_CFLAGS := -ccopt -I$(DYCKCFL_DIR) -ccopt -I$(REGION_DIR) -ccopt -I$(ENGINE_DIR)

export LOCKSMITH_MODULES
export LOCKSMITH_CMODULES
#export LINKFLAGS
export CAML_CFLAGS
export CP4S

all:
	$(AT)$(MAKE) -C banshee NO_BANSHEE_ROLLBACK=1 NO_HASH_BOUNDS=1 all
	$(AT)LINKFLAGS="$(LINKFLAGS)" $(MAKE) -C cil

profile:
	$(AT)$(MAKE) -C banshee NO_BANSHEE_ROLLBACK=1 NO_HASH_BOUNDS=1 DEBUG=1 DEBUG_RALLOC=1 all
	$(AT)LINKFLAGS="$(LINKFLAGS)" $(MAKE) -C cil PROFILE=1

clean:
	$(AT)$(MAKE) -C banshee clean
	$(AT)$(MAKE) -C cil clean

=== banshee/Makefile ===
# Copyright (c) 2000-2004
#      The Regents of the University of California.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.

BANSHEE_VERSION := banshee-1.02
DISTRIB_ROOT := /tmp
DISTRIB_DIR := $(DISTRIB_ROOT)/$(BANSHEE_VERSION)

.PHONY: banshee libcompat codegen engine tests andersen steensgaard \
	lambda dyckcfl docs points-to install perf ibanshee java distrib \
#	rca rlib

all: banshee ibanshee tests points-to 

banshee: libcompat codegen engine #rlib

libcompat: 
	$(MAKE) -C libcompat

#rlib:
#	$(MAKE) -C rlib

codegen: 
	$(MAKE) -C codegen

engine:
	$(MAKE) -C engine

rca: banshee
	$(MAKE) -C rca

andersen: banshee
	$(MAKE) -C andersen

steensgaard: banshee
	$(MAKE) -C steensgaard

points-to: andersen steensgaard
	$(MAKE) -C cparser

ibanshee: banshee
	$(MAKE) -C ibanshee

lambda: banshee
	$(MAKE) -C lambda

dyckcfl: banshee
	$(MAKE) -C dyckcfl

java: banshee dyckcfl
	$(MAKE) -C java

tests: banshee andersen steensgaard lambda dyckcfl # rca
	$(MAKE) -C tests

docs: 
	$(MAKE) -C docs

check: 
	$(MAKE) -C tests check
	$(MAKE) -C tests -f pta_test.mk
ifndef NO_BANSHEE_ROLLBACK
	$(MAKE) -C tests -f pta_test.mk pta-bt-regr
#	$(MAKE) -C tests -f pta_test.mk pta-persist-regr
endif
#ifdef RLIB
	$(MAKE) -C tests -f pta_test.mk pta-rpersist-regr
#endif
	$(MAKE) -C tests -f ibanshee_test.mk
ifndef NO_BANSHEE_ROLLBACK
	$(MAKE) -C tests -f ibanshee_test.mk ibanshee-bt
#	$(MAKE) -C tests -f ibanshee_test.mk ibanshee-persist
endif
#ifdef RLIB
	$(MAKE) -C tests -f ibanshee_test.mk ibanshee-rpersist
#endif
	@echo "SUCCESS: All check targets passed."

rpersist_check:
	$(MAKE) -C tests check/region-persist-test.exe
	$(MAKE) -C tests -f ibanshee_test.mk ibanshee-rpersist
	$(MAKE) -C tests -f pta_test.mk pta-rpersist-regr
	@echo "SUCCESS: All region persistence check targets passed."

perf:
	$(MAKE) -C tests -f pta_perf.mk

install:
	@echo "banshee does not have an install target."

clean:
	$(MAKE) -C libcompat clean
#	$(MAKE) -C rlib clean
	$(MAKE) -C codegen clean
	$(MAKE) -C engine clean
	$(MAKE) -C rca clean
	$(MAKE) -C andersen clean
	$(MAKE) -C steensgaard clean
	$(MAKE) -C cparser clean
	$(MAKE) -C lambda clean
	$(MAKE) -C dyckcfl clean
	$(MAKE) -C tests clean
	$(MAKE) -C docs clean
	$(MAKE) -C tests -f pta_test.mk clean
	$(MAKE) -C tests -f ibanshee_test.mk clean
	$(MAKE) -C ibanshee clean
	$(MAKE) -C java clean
	rm -rf *~ data statics offsets extras banshee*.tar.gz

distrib: clean docs
	rm -rf $(DISTRIB_DIR)
	mkdir $(DISTRIB_DIR)
# make a documentation directory and copy the documentation over
	mkdir $(DISTRIB_DIR)/docs
	cp docs/Makefile $(DISTRIB_DIR)/docs/
	cp docs/banshee-manual.pdf $(DISTRIB_DIR)/docs/
	cp docs/pldi04-kodumal.pdf $(DISTRIB_DIR)/docs/
	cp docs/sas05-kodumal.pdf $(DISTRIB_DIR)/docs/
# make an engine directory and copy the sources over
	mkdir $(DISTRIB_DIR)/engine
	cp engine/Makefile $(DISTRIB_DIR)/engine/
	cp engine/*.c $(DISTRIB_DIR)/engine/
	cp engine/*.h $(DISTRIB_DIR)/engine/
# make a bin directory and copy the sources over
	mkdir $(DISTRIB_DIR)/bin
	cp bin/build_funptr_table.py $(DISTRIB_DIR)/bin/
# make an andersen directory and copy the sources over
	mkdir $(DISTRIB_DIR)/andersen
	cp andersen/Makefile $(DISTRIB_DIR)/andersen/
	cp andersen/*.h $(DISTRIB_DIR)/andersen/
	cp andersen/*.bsp $(DISTRIB_DIR)/andersen/
	cp andersen/*.c $(DISTRIB_DIR)/andersen/
# make a codegen directory and copy the sources over
	mkdir $(DISTRIB_DIR)/codegen
	cp -r codegen/* $(DISTRIB_DIR)/codegen
	rm -rf $(DISTRIB_DIR)/codegen/CVS
# make a cparser directory and copy the sources over (make an mobj dir, too)
	mkdir $(DISTRIB_DIR)/cparser
	cp -r cparser/* $(DISTRIB_DIR)/cparser
	rm -rf $(DISTRIB_DIR)/cparser/CVS
	rm -rf $(DISTRIB_DIR)/cparser/mobj/CVS
	rm -rf $(DISTRIB_DIR)/cparser/robj/CVS
	rm -rf $(DISTRIB_DIR)/cparser/obj/CVS
# make a dyckcfl directory and copy the sources over
	mkdir $(DISTRIB_DIR)/dyckcfl
	cp dyckcfl/*.c $(DISTRIB_DIR)/dyckcfl/
	cp dyckcfl/*.h $(DISTRIB_DIR)/dyckcfl/
	cp dyckcfl/*.bsp $(DISTRIB_DIR)/dyckcfl/
	cp dyckcfl/Makefile $(DISTRIB_DIR)/dyckcfl/
# make an ibanshee directory and copy the sources over
	mkdir $(DISTRIB_DIR)/ibanshee
	cp ibanshee/parser.y $(DISTRIB_DIR)/ibanshee/
	cp ibanshee/lexer.lex $(DISTRIB_DIR)/ibanshee/
	cp ibanshee/Makefile $(DISTRIB_DIR)/ibanshee/
# make a java directory and copy the sources over
	mkdir $(DISTRIB_DIR)/java
	cp java/Makefile $(DISTRIB_DIR)/java/
# make an rca directory and copy the sources over
	mkdir $(DISTRIB_DIR)/rca
	cp rca/Makefile $(DISTRIB_DIR)/rca/
# make a lambda directory and copy the sources over
	mkdir $(DISTRIB_DIR)/lambda
	cp lambda/lambda.bsp $(DISTRIB_DIR)/lambda/
	cp lambda/Makefile $(DISTRIB_DIR)/lambda/
# make a libcompat directory and copy the sources over
	mkdir $(DISTRIB_DIR)/libcompat
	cp -r libcompat/ $(DISTRIB_DIR)/libcompat/
	rm -rf $(DISTRIB_DIR)/libcompat/CVS
# make an rlib directory and copy the sources over
#	mkdir $(DISTRIB_DIR)/rlib
#	cp -r rlib/ $(DISTRIB_DIR)/rlib/
#	rm -rf $(DISTRIB_DIR)/rlib/CVS
#	rm -rf $(DISTRIB_DIR)/rlib/test/
# make a steensgaard directory and copy the sources over
	mkdir $(DISTRIB_DIR)/steensgaard
	cp steensgaard/*.bsp $(DISTRIB_DIR)/steensgaard/
	cp steensgaard/*.c $(DISTRIB_DIR)/steensgaard/
	cp steensgaard/*.h $(DISTRIB_DIR)/steensgaard/
	cp steensgaard/Makefile $(DISTRIB_DIR)/steensgaard/
# make a tests directory and copy the sources over
	mkdir $(DISTRIB_DIR)/tests
	mkdir $(DISTRIB_DIR)/tests/test.cor
	mkdir $(DISTRIB_DIR)/tests/test.ibc
	mkdir $(DISTRIB_DIR)/tests/test.ibc.cor
	mkdir $(DISTRIB_DIR)/tests/test.programs
	cp tests/*.mk $(DISTRIB_DIR)/tests/
	cp tests/*.py $(DISTRIB_DIR)/tests/
	cp tests/*.c $(DISTRIB_DIR)/tests/
	cp tests/Makefile $(DISTRIB_DIR)/tests/
	cp tests/test.cor/*.cor $(DISTRIB_DIR)/tests/test.cor/
	cp -r tests/test.ibc/ $(DISTRIB_DIR)/tests/test.ibc/
	rm -rf $(DISTRIB_DIR)/tests/test.ibc/CVS
	rm -rf $(DISTRIB_DIR)/tests/test.ibc/bt/CVS
	rm -rf $(DISTRIB_DIR)/tests/test.ibc/persist/CVS
	rm -rf $(DISTRIB_DIR)/tests/test.ibc/rpersist/CVS
	cp -r tests/test.ibc.cor/ $(DISTRIB_DIR)/tests/test.ibc.cor/
	rm -rf $(DISTRIB_DIR)/tests/test.ibc.cor/CVS
	rm -rf $(DISTRIB_DIR)/tests/test.ibc.cor/bt/CVS
	rm -rf $(DISTRIB_DIR)/tests/test.ibc.cor/persist/CVS
	rm -rf $(DISTRIB_DIR)/tests/test.ibc.cor/rpersist/CVS
	cp -r tests/test.programs/* $(DISTRIB_DIR)/tests/test.programs/
	rm -rf $(DISTRIB_DIR)/tests/test.programs/CVS
	rm -rf $(DISTRIB_DIR)/tests/test.programs/cqual.preproc/CVS
	rm -rf $(DISTRIB_DIR)/tests/test.programs/espresso.preproc/CVS
	rm -rf $(DISTRIB_DIR)/tests/test.programs/li.preproc/CVS
	rm -rf $(DISTRIB_DIR)/tests/test.programs/ML-typecheck.preproc/CVS
# copy Makefile, README, and COPYRIGHT
	cp Makefile $(DISTRIB_DIR)/
	cp README $(DISTRIB_DIR)/
	cp COPYRIGHT $(DISTRIB_DIR)/
# get rid of all .svn dirs
	rm -rf $(DISTRIB_DIR)/.svn
	rm -rf $(DISTRIB_DIR)/andersen/.svn
	rm -rf $(DISTRIB_DIR)/bin/.svn
	rm -rf $(DISTRIB_DIR)/codegen/.svn
	rm -rf $(DISTRIB_DIR)/cparser/.svn
	rm -rf $(DISTRIB_DIR)/cparser/mobj/.svn
	rm -rf $(DISTRIB_DIR)/docs/.svn
	rm -rf $(DISTRIB_DIR)/dyckcfl/.svn
	rm -rf $(DISTRIB_DIR)/engine/.svn
	rm -rf $(DISTRIB_DIR)/experiments/.svn
	rm -rf $(DISTRIB_DIR)/experiments/logs/.svn
	rm -rf $(DISTRIB_DIR)/ibanshee/.svn
	rm -rf $(DISTRIB_DIR)/java/.svn
	rm -rf $(DISTRIB_DIR)/java/banshee/.svn
	rm -rf $(DISTRIB_DIR)/java/banshee/engine/.svn
	rm -rf $(DISTRIB_DIR)/java/conflux/.svn
	rm -rf $(DISTRIB_DIR)/java/conflux/builder/.svn
	rm -rf $(DISTRIB_DIR)/java/conflux/flowgraph/.svn
	rm -rf $(DISTRIB_DIR)/java/conflux/util/.svn
	rm -rf $(DISTRIB_DIR)/java/jbanshee/.svn
	rm -rf $(DISTRIB_DIR)/java/jbanshee/dyckcfl/.svn
	rm -rf $(DISTRIB_DIR)/java/jbanshee/engine/.svn
	rm -rf $(DISTRIB_DIR)/lambda/.svn
	rm -rf $(DISTRIB_DIR)/libcompat/.svn
	rm -rf $(DISTRIB_DIR)/rca/.svn
	rm -rf $(DISTRIB_DIR)/rlib/.svn
	rm -rf $(DISTRIB_DIR)/rlib/test/.svn
	rm -rf $(DISTRIB_DIR)/rlib/test/0/.svn
	rm -rf $(DISTRIB_DIR)/rlib/test/1/.svn
	rm -rf $(DISTRIB_DIR)/rlib/test/2/.svn
	rm -rf $(DISTRIB_DIR)/rlib/test/3/.svn
	rm -rf $(DISTRIB_DIR)/rlib/test/4/.svn
	rm -rf $(DISTRIB_DIR)/rlib/test/5/.svn
	rm -rf $(DISTRIB_DIR)/rlib/test/6/.svn
	rm -rf $(DISTRIB_DIR)/rlib/test/7/.svn
	rm -rf $(DISTRIB_DIR)/steensgaard/.svn
	rm -rf $(DISTRIB_DIR)/tests/.svn
	rm -rf $(DISTRIB_DIR)/tests/delta/.svn
	rm -rf $(DISTRIB_DIR)/tests/test.cor/.svn
	rm -rf $(DISTRIB_DIR)/tests/test.ibc/.svn
	rm -rf $(DISTRIB_DIR)/tests/test.ibc/bt/.svn
	rm -rf $(DISTRIB_DIR)/tests/test.ibc/persist/.svn
	rm -rf $(DISTRIB_DIR)/tests/test.ibc/rpersist/.svn
	rm -rf $(DISTRIB_DIR)/tests/test.ibc.cor/.svn
	rm -rf $(DISTRIB_DIR)/tests/test.ibc.cor/bt/.svn
	rm -rf $(DISTRIB_DIR)/tests/test.ibc.cor/persist/.svn
	rm -rf $(DISTRIB_DIR)/tests/test.ibc.cor/rpersist/.svn
	rm -rf $(DISTRIB_DIR)/tests/test.programs/.svn
	rm -rf $(DISTRIB_DIR)/tests/test.programs/cqual.preproc/.svn
	rm -rf $(DISTRIB_DIR)/tests/test.programs/espresso.preproc/.svn
	rm -rf $(DISTRIB_DIR)/tests/test.programs/li.preproc/.svn
	rm -rf $(DISTRIB_DIR)/tests/test.programs/ML-typecheck.preproc/.svn
#tar and zip the distrib directory
	cd $(DISTRIB_ROOT); tar cfz $(BANSHEE_VERSION).tar.gz $(BANSHEE_VERSION)
	mv $(DISTRIB_ROOT)/$(BANSHEE_VERSION).tar.gz .

=== banshee/andersen/Makefile ===
# Copyright (c) 2000-2004
#      The Regents of the University of California.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.

#ifndef RLIB
region_dir = ../libcompat
#else
#region_dir = ../rlib
#endif

banshee_bindir = ../bin
engine_dir = ../engine

BANSHEE = $(banshee_bindir)/banshee.exe

ANDERSEN = andersen_terms

ANDERSEN_ST = andersen_terms_st

ANDERSEN_NS = andersen_terms_nonspec

TARGETS =  andersen.o $(ANDERSEN).h $(ANDERSEN).c $(ANDERSEN).o \
           $(ANDERSEN_NS).o

TAGFILES = *.c *.h

#CC = gcc

ifdef DEBUG
CFLAGS = -Wall -pg -g -I$(engine_dir) -I$(region_dir) -Ddeletes=	\
         -Dtraditional= -Dsameregion= -Dparentptr= -Werror -fno-strict-aliasing -DREGION_PROFILE
else
CFLAGS = -DNDEBUG -O3 -I$(engine_dir) -I$(region_dir) -Ddeletes= \
         -Dtraditional= -Dsameregion= -Dparentptr= -Wall -Werror -fno-strict-aliasing
endif

all: $(TARGETS)

andersen.o: $(ANDERSEN).h

$(ANDERSEN_NS).o : $(BANSHEE) $(ANDERSEN_NS).c
	$(CC) -c $(CFLAGS) -DNONSPEC $(ANDERSEN_NS).c

$(ANDERSEN).c: $(ANDERSEN).bsp $(BANSHEE)
	$(BANSHEE) $(ANDERSEN).bsp $(ANDERSEN)
	indent -npsl $@

$(ANDERSEN).h: $(ANDERSEN).c
	indent -npsl $@

$(ANDERSEN_ST).c: $(ANDERSEN_ST).bsp $(BANSHEE)
	$(BANSHEE) $(ANDERSEN_ST).bsp $(ANDERSEN_ST)
	indent -npsl $@ 

$(ANDERSEN_ST).h: $(ANDERSEN_ST).c
	indent -npsl $@ 

TAGS: $(TAGFILES)
	etags $(TAGFILES)

# build banshee if necessary
$(BANSHEE): 
	$(MAKE) -C ../ banshee

.PHONY: clean

clean:
	rm -f $(TARGETS) *~ *BAK

=== banshee/codegen/Makefile ===
# Copyright (c) 2000-2004
#      The Regents of the University of California.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.

OCAMLMAKEFILE = OcamlMakefile

SOURCES = cgen.mli cgen.ml engspec.ml spec_to_c.mli spec_to_c.ml \
	 sort_utils.ml  set_sort.mli set_sort.ml row_sort.ml \
	  term_sort.ml parser.mly lexer.mll build.ml
LIBS = str

RESULT = ../bin/banshee.exe

TRASH = *~

all: byte-code 

-include $(OCAMLMAKEFILE)

=== banshee/dyckcfl/Makefile ===
# Copyright (c) 2000-2004
#      The Regents of the University of California.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.

#OS:=$(shell uname)

#ifeq ($(OS), Darwin)
#	jni_dir = /System/Library/Frameworks/JavaVM.framework/Headers 
#else 
#	jni_dir = /usr/local/java/include/
#endif

#ifndef RLIB
region_dir = ../libcompat
#else
#region_dir = ../rlib
#endif

engine_dir = ../engine
banshee_bindir = ../bin
banshee_exe = ../bin/banshee.exe

DYCKCFL = dyckcfl

TARGETS =  $(DYCKCFL).o mr_$(DYCKCFL).o $(DYCKCFL)_terms.h $(DYCKCFL)_spec.o $(DYCKCFL)_terms.c $(DYCKCFL)_terms.o dyckcfl-replay.o dyckcfl-replay

TAGFILES = $(wildcard *.c) $(wildcard *.h)

#CC = gcc

ifdef DEBUG
CFLAGS = -I$(engine_dir) -I$(region_dir) -Ddeletes= -Dtraditional= \
         -Dsameregion= -Dparentptr= -Wall -Werror -g -pg \
	 -DREGION_PROFILE
#
else
CFLAGS = -I$(engine_dir) -I$(region_dir) -Ddeletes= -Dtraditional= \
         -Dsameregion= -Dparentptr= -Wall -Werror \
	 -DREGION_PROFILE
#
endif

.PHONY: clean 

all: $(TARGETS) 

mr_$(DYCKCFL).o: mr_$(DYCKCFL).c mr_$(DYCKCFL).h
	$(CC) -c $(CFLAGS) -DNONSPEC mr_$(DYCKCFL).c

$(DYCKCFL).o: $(DYCKCFL).c $(DYCKCFL).h
	$(CC) -c $(CFLAGS) -DNONSPEC $(DYCKCFL).c

$(DYCKCFL)_terms.h: $(DYCKCFL)_terms.bsp
	$(banshee_exe) $(DYCKCFL)_terms.bsp

$(DYCKCFL)_terms.c: $(DYCKCFL)_terms.bsp
	$(banshee_exe) $(DYCKCFL)_terms.bsp

TAGS: $(TAGFILES)
	etags $(TAGFILES)

#detect:
#	@echo "OS is $(OS)"

#jdyckcfl:
#	javac JDyckCFL.java
#	javah -jni JDyckCFL
#	$(CC) -c -I$(engine_dir) -I$(region_dir) -I$(jni_dir) -Ddeletes= \
#	-Dtraditional= -Dsameregion= -Dparentptr= -DNONSPEC -Wall JDyckCFLImp.c
#	$(CC) -dynamiclib -o libjdyckcfl.jnilib dyckcfl.o JDyckCFLImp.o $(engine_dir)/libnsengine.a $(region_dir)/libregions.a -framework JavaVM

dyckcfl-replay: dyckcfl-replay.o $(DYCKCFL).o
	$(CC) $(CFLAGS) dyckcfl-replay.o $(DYCKCFL).o -o dyckcfl-replay -L$(region_dir) -L$(engine_dir) -lnsengine -lregions

clean:
	rm -f $(TARGETS) *~ JDyckCFL.class JDyckCFLImp.o libjdyckcfl.jnilib

=== banshee/engine/Makefile ===
# Copyright (c) 2000-2004
#      The Regents of the University of California.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.

ifdef NO_HASH_BOUNDS
FILTEREDOBJS = hash_bounds.o
else
FILTEREDOBJS = bounds.o
endif

FILTEREDOBJS += malloc.o
NONSPEC_OBJ = nonspec.o

#ifndef RLIB
region_dir = ../libcompat
#else
#region_dir = ../rlib
#endif

#CC = gcc

CFLAGS = -I. -I$(region_dir) -Ddeletes= -Dtraditional= -Dsameregion= \
	 -Dparentptr= -Wall -Werror -fno-strict-aliasing -fno-common \
 -DREGION_PROFILE

ifndef NO_BANSHEE_ROLLBACK
CFLAGS := -DBANSHEE_ROLLBACK ${CFLAGS}
endif

#HDRS = $(wildcard *.h)

HDRS = annotations.h array.h banshee.h banshee_persist_kinds.h banshee_region_persist_kinds.h bfix.h bool.h bounds.h buffer.h compiler.h cstring.h flow-var.h flowrow-sort.h hash.h hashset.h jcollection.h linkage.h list.h nonspec.h persist.h regexp.h setif-sort.h setif-var.h setst-sort.h setst-var.h stamp.h term-sort.h term-var.h termhash.h ufind.h usage.h utils.h

COBJS = array.c banshee.c banshee_persist_kinds.c banshee_region_persist_kinds.c bfix.c bounds.c buffer.c epsilon-annotations.c flow-var.c flowrow-sort.c hash.c hash_bounds.c hashset.c jcollection.c list.c malloc.c nonspec.c persist.c regexp.c setif-sort.c setif-var.c setst-sort.c setst-var.c stamp.c term-sort.c term-var.c termhash.c ufind.c usage.c utils.c

NFOBJS = $(patsubst %.c,%.o,$(COBJS))

AOBJS = $(filter-out $(FILTEREDOBJS), $(NFOBJS))

OBJS = $(filter-out $(NONSPEC_OBJ), $(AOBJS))

NSOBJS = $(patsubst %.o,%.ns.o,$(AOBJS))

#TAGFILES = $(wildcard *.c) $(wildcard *.h)

TARGETS = libengine.a libnsengine.a 

ifdef DEBUG
CFLAGS := -pg -g ${CFLAGS}
else
CFLAGS := -DNDEBUG -O3 ${CFLAGS}
endif

all: $(TARGETS) 

libengine.a: $(OBJS)
	@echo $(OBJS)
	../bin/build_funptr_table.py $(OBJS) > fn_ptrs.c
	$(CC) -c $(CFLAGS) fn_ptrs.c -o fn_ptrs.o
	$(AR) rcs $@ $^ fn_ptrs.o

libnsengine.a: $(NSOBJS) 
	@echo $(NSOBJS)
	../bin/build_funptr_table.py $(NSOBJS) > fn_ptrs.ns.c
	$(CC) -c $(CFLAGS) fn_ptrs.ns.c -o fn_ptrs.o
	$(AR) rcs $@ $^ fn_ptrs.o

nonspec.o: nonspec.c nonspec.h
	$(CC) -c $(CFLAGS) -DNONSPEC $(CPPFLAGS) $< -o $@

%.ns.o: %.c $(HDRS)
	$(CC) -c $(CFLAGS) -DNONSPEC $(CPPFLAGS) $< -o $@

%.o : %.c $(HDRS)
	$(CC) -c $(CFLAGS) $(CPPFLAGS) $< -o $@

.PHONY: clean

#TAGS: $(TAGFILES)
#	etags ${TAGFILES}

clean:
	-rm -f *.o $(TARGETS) *~ fn_ptrs.ns.c fn_ptrs.c

=== banshee/ibanshee/Makefile ===
# Copyright (c) 2000-2004
#      The Regents of the University of California.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.

#ifndef RLIB
region_dir = ../libcompat
#else
#region_dir = ../rlib
#endif

all: ibanshee.exe

ibanshee.exe: parser.tab.c lex.yy.c
	$(CC) -DNONSPEC -Ddeletes= -Dtraditional= -Dsameregion= \
	 -Dparentptr=  -o ibanshee.exe lex.yy.c parser.tab.c -I../engine -I$(region_dir) -L../engine -L$(region_dir) -lnsengine -lregions -lfl 
	cp ibanshee.exe ../bin

parser.tab.c: parser.y
	bison -d parser.y

lex.yy.c: lexer.lex
	flex lexer.lex

clean: 
	rm -rf *.o parser.tab.h parser.tab.c lex.yy.c gmon.out ../bin/ibanshee.exe ibanshee.exe *~

=== banshee/java/Makefile ===
# Copyright (c) 2000-2004
#      The Regents of the University of California.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.

OS:=$(shell uname)

#CC = gcc

#ifeq ($(OS), Darwin)
#	jni_dir = /System/Library/Frameworks/JavaVM.framework/Headers 
# TODO --- this is not a platform agnostic way of finding the jni headers
#else 
	jni_dir = $(JAVA_HOME)/include/
#endif

#ifndef RLIB
region_dir = ../libcompat
#else
#region_dir = ../rlib
#endif

engine_dir = ../engine

dyckcfl_dir = ../dyckcfl

all: java jdyckcfl

.PHONY: java jdyckcfl check

java:
	javac `find jbanshee -name \*.java`

conflux: java
	javac `find conflux -name \*.java`

jdyckcfl: java 
	javah -jni jbanshee.dyckcfl.UnsafeDyckCFL
	$(CC) -c -I. -I$(dyckcfl_dir) -I$(engine_dir) -I$(region_dir) -I$(jni_dir) -Ddeletes= \
	-Dtraditional= -Dsameregion= -Dparentptr= -DNONSPEC -Wall \
	jbanshee/dyckcfl/UnsafeDyckCFLImp.c
	$(CC) -dynamiclib -o libjdyckcfl.jnilib $(dyckcfl_dir)/dyckcfl.o UnsafeDyckCFLImp.o $(engine_dir)/libnsengine.a $(region_dir)/libregions.a -framework JavaVM

check: java jdyckcfl
	java jbanshee.dyckcfl.UnsafeDyckCFL

clean:
	rm -f *.o libjdyckcfl.jnilib jbanshee_dyckcfl_UnsafeDyckCFL.h 
	rm -f `find . -name \*.class`
	rm -f `find . -name \*~`

=== banshee/lambda/Makefile ===
# Copyright (c) 2000-2004
#      The Regents of the University of California.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.

#ifndef RLIB
region_dir = ../libcompat
#else
#region_dir = ../rlib
#endif

engine_dir = ../engine
banshee_bindir = ../bin

BANSHEE = $(banshee_bindir)/banshee.exe

LAMBDA = lambda

TARGETS =  $(LAMBDA).h $(LAMBDA).c $(LAMBDA).o 

TAGFILES = $(LAMBDA).h $(LAMBDA).c

#CC = gcc

ifdef DEBUG
CFLAGS = -I$(engine_dir) -I$(region_dir) -Ddeletes= -Dtraditional= \
         -Dsameregion= -Dparentptr= -Wall -Werror -g -pg
else
CFLAGS = -I$(engine_dir) -I$(region_dir) -Ddeletes= -Dtraditional= \
         -Dsameregion= -Dparentptr= -Wall -Werror
endif


.PHONY: clean

all: $(TARGETS)

$(LAMBDA).c: $(LAMBDA).bsp $(BANSHEE)
	$(BANSHEE) $(LAMBDA).bsp $(LAMBDA)
	indent -npsl $@ 

$(LAMBDA).h: $(LAMBDA).c
	indent -npsl $@ 

TAGS: $(TAGFILES)
	etags $(TAGFILES)

# build banshee if necessary
$(BANSHEE): 
	$(MAKE) -C ../ banshee

clean:
	rm -f $(TARGETS) *~ *BAK

=== banshee/libcompat/Makefile ===
# Copyright (c) 2000-2004
#      The Regents of the University of California.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.

#CC=gcc

ifdef DEBUG_RALLOC
CFLAGS = -g -pg -Wall -Ddeletes="" -DDEBUG_RALLOC -DNDEBUG -DNMEMDEBUG  -Werror -fno-common
else
CFLAGS = -Wall -Ddeletes="" -DNMEMDEBUG -DNDEBUG -Werror -fno-common
endif

TAGFILES = $(wildcard *.c) $(wildcard *.h)

TARGETS = libregions.a 

all: $(TARGETS) 

regions.o: serialize.c regions.c pages.c alloc.c regions.h stats.c
	$(CC) -c $(CFLAGS) -o regions.o regions.c

profile.o: profile.c
	$(CC) -c $(CFLAGS) -o profile.o profile.c

libregions.a: regions.o profile.o
	$(AR) rcs $@ $^

TAGS: $(TAGFILES)
	etags $(TAGFILES)

.PHONY: clean

clean:
	rm -f $(TARGETS) regions.o profile.o *~

=== banshee/rca/Makefile ===
# Copyright (c) 2000-2004
#      The Regents of the University of California.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.


#ifndef RLIB
region_dir = ../libcompat
#else
#region_dir = ../rlib
#endif

engine_dir = ../engine
banshee_bindir = ../bin

BANSHEE= $(banshee_bindir)/banshee.exe

RCA = rca_types

TARGETS =  $(RCA).h $(RCA).c $(RCA).o rca_analyze.o 

TAGFILES = *.c *.h

#CC = gcc

ifdef DEBUG
CFLAGS = -pg -g -I$(engine_dir) -I$(region_dir) -Ddeletes= -Dtraditional= \
         -Dsameregion= -Dparentptr= -Wall -Werror
else
CFLAGS = -DNDEBUG -O3 -I$(engine_dir) -I$(region_dir) -Ddeletes= \
         -Dtraditional= -Dsameregion= -Dparentptr= -Wall -Werror
endif

.PHONY: clean

all: $(TARGETS) #TAGS

$(RCA).c: $(RCA).bsp $(BANSHEE)
	$(BANSHEE) $(RCA).bsp $(RCA)
	indent -npsl $@ 

$(RCA).h: $(RCA).c
	indent -npsl $@ 

TAGS: $(TAGFILES)
	etags $(TAGFILES)

# build banshee if necessary
$(BANSHEE): 
	$(MAKE) -C ../ banshee

clean:
	rm -f $(TARGETS) *~ *BAK

=== banshee/steensgaard/Makefile ===
# Copyright (c) 2000-2004
#      The Regents of the University of California.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.

#ifndef RLIB
region_dir = ../libcompat
#else
#region_dir = ../rlib
#endif

banshee_bindir = ../bin
engine_dir = ../engine

BANSHEE = $(banshee_bindir)/banshee.exe

STEENSGAARD = steensgaard_terms

STEENSGAARD_NOTAG = steensgaard_terms_notag

TARGETS = steensgaard.o steensgaard_notag.o $(STEENSGAARD).h $(STEENSGAARD).c $(STEENSGAARD).o $(STEENSGAARD_NOTAG).h $(STEENSGAARD_NOTAG).c $(STEENSGAARD_NOTAG).o

TAGFILES = *.c *.h

#CC = gcc

ifdef DEBUG
CFLAGS = -Wall -pg -g -I$(engine_dir) -I$(region_dir) -Ddeletes=	\
         -Dtraditional= -Dsameregion= -Dparentptr= -Werror -fno-strict-aliasing -DREGION_PROFILE
else
CFLAGS = -DNDEBUG -O3 -I$(engine_dir) -I$(region_dir) -Ddeletes= \
         -Dtraditional= -Dsameregion= -Dparentptr= -Wall -Werror -fno-strict-aliasing
endif

all: $(TARGETS)

steensgaard.o: $(STEENSGAARD).h
	$(CC) $(CFLAGS) -c -o steensgaard.o steensgaard.c

steensgaard_notag.o: $(STEENSGAARD_NOTAG).h
	$(CC) $(CFLAGS) -DNOTAG -c -o steensgaard_notag.o steensgaard.c

$(STEENSGAARD).c: $(STEENSGAARD).bsp $(BANSHEE)
	$(BANSHEE) $(STEENSGAARD).bsp $(STEENSGAARD)
	indent -npsl $@

$(STEENSGAARD).h: $(STEENSGAARD).c
	indent -npsl $@

$(STEENSGAARD_NOTAG).c: $(STEENSGAARD_NOTAG).bsp $(BANSHEE)
	$(BANSHEE) $(STEENSGAARD_NOTAG).bsp $(STEENSGAARD_NOTAG)
	indent -npsl $@

$(STEENSGAARD_NOTAG).h: $(STEENSGAARD_NOTAG).c
	indent -npsl $@

TAGS: $(TAGFILES)
	etags $(TAGFILES)

# build banshee if necessary
$(BANSHEE): 
	$(MAKE) -C ../ banshee

.PHONY: clean

clean:
	rm -f $(TARGETS) *~ *BAK

=== cil/debian/changelog ===
cil (1.3.6-1) unstable; urgency=low

  * New upstream release

 -- Luis Cañas Díaz <lcanas@gsyc.es>  Fri, 15 Jan 2008 14:00:52 +0200

cil (1.3.5-1) unstable; urgency=low

  * New upstream release

 -- Luis Cañas Díaz <lcanas@gsyc.es>  Tue, 17 Apr 2007 18:30:53 +0200

cil (1.3.2-1) unstable; urgency=low

  * New upstream release

 -- Ben Liblit <liblit@cs.wisc.edu>  Sat,  5 Mar 2005 22:08:14 -0600

cinterlang (1.3.1-1) unstable; urgency=low

  * New upstream release

 -- Jesus M. Gonzalez-Barahona <jgb@debian.org>  Thu, 19 Aug 2004 15:46:39 +0000

cinterlang (1.2.5-1) unstable; urgency=low

  * Initial Release.

 -- Jesus M. Gonzalez-Barahona <jgb@debian.org>  Wed, 18 Aug 2004 00:40:43 +0200

=== cil/debian/control ===
Source: cil
Section: devel
Priority: optional
Maintainer: Ben Liblit <liblit@cs.wisc.edu>
Build-Depends: autotools-dev, debhelper (>= 4.0.0), fakeroot, hevea, libc6-i686, libncurses5-dev, locales, ocaml-base-nox (>= 3.08), ocaml-interp (>= 3.08), ocaml-nox (>= 3.08), perl-base (>= 5.6.1)
Standards-Version: 3.6.1

Package: cil
Architecture: any
Depends: perl (>= 5.6.1)
Description: OCaml library for C program analysis and transformation
 CIL (C Intermediate Language) is a high-level representation along
 with a set of tools that permit easy analysis and source-to-source
 transformation of C programs.
 .
 This package provides Perl modules which are useful for building
 compiler wrappers.  A wrapper can use CIL to transform C code before
 passing it along to the native C compiler.

Package: cil-dev
Architecture: any
Depends: ocaml (>= 3.08)
Description: OCaml library for C program analysis and transformation
 CIL (C Intermediate Language) is a high-level representation along
 with a set of tools that permit easy analysis and source-to-source
 transformation of C programs.
 .
 This package provides OCaml interfaces and an OCaml library which form
 the CIL API.

=== cil/debian/rules ===
#!/usr/bin/make -f

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

config.status: configure
	dh_testdir
	# Add here commands to configure the package.
	CFLAGS="$(CFLAGS)" ./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info

build: debian/build-stamp

debian/build-stamp:  config.status
	dh_testdir
	# Add here commands to compile the package.
	$(MAKE) setup #doc
	touch $@

check:	build
	$(MAKE) check


clean:	config.status
	dh_testdir
	dh_testroot
	rm -f debian/build-stamp 
	# Add here commands to clean up after the build process.
	-$(MAKE) distclean
	rm -f config.status
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp
	mkdir -p $(CURDIR)/debian/tmp/usr/share/doc/cil/html
	mkdir -p $(CURDIR)/debian/tmp/usr/share/doc/cil-dev
	cp LICENSE $(CURDIR)/debian/tmp/usr/share/doc/cil/
	cp LICENSE $(CURDIR)/debian/tmp/usr/share/doc/cil-dev/
	#cp -f doc/*.html $(CURDIR)/debian/tmp/usr/share/doc/cil/html
	#cp -f doc/*.gif $(CURDIR)/debian/tmp/usr/share/doc/cil/html
	#cp -a doc/api $(CURDIR)/debian/tmp/usr/share/doc/cil/html
	#cp -a doc/*.pdf $(CURDIR)/debian/tmp/usr/share/doc/cil
	#cp -a doc/examples $(CURDIR)/debian/tmp/usr/share/doc/cil

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_install --list-missing --sourcedir=$(CURDIR)/debian/tmp
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== cil/debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# Site		Directory		Pattern			Version	Script
version=2
http://manju.cs.berkeley.edu/cil/distrib/cil-(.*)\.tar\.gz
